Attribute VB_Name = "Config"
Option Explicit

Global Const cs_hostmode As String = "HOST MODE"
Global Const cs_nonhostmode As String = "NON-HOST MODE"
Global Const logSize As Long = 1024000
Global Const logBackups As Integer = 3
Global Const gMaintenancePwd As String = ""     'Password to get into maintenance screen. Leave empty if don't need.

'Clippership fields used.
Global Const gProcModeField As String = "baxs_apt"
Global Const gNetSkidField As String = "baxh_apt"
Global Const gPcsOnSkidsField As String = "qty"
Global Const gLoosePcsField As String = "akhi_chg"
Global Const gTotalPcsField As String = "reg_amt"
Global Const gShipNumField As String = "lgd_chg"
Global Const gPoField As String = "po_no"        'Field where we are storing po number.

'Constants
Global Const gRecordMode_Shipment As Integer = 0 'Recording one record per shipment.
Global Const gRecordMode_Piece As Integer = 1    'Recording one record per skid/loose piece.

Public Sub Maintenance()

  'Receives: Nothing.
  'Returns: Nothing.
  'Provides access to various maintenance functions. Asks for password before getting in, if gMaintenancePwd is not empty.
  
  If Len(Trim(gMaintenancePwd)) = 0 Then
    DoMaintenance
  ElseIf GetPassword(gMaintenancePwd) Then
    DoMaintenance
  End If
  
End Sub

Private Sub DoMaintenance()

  'Receives: Nothing.
  'Returns: Nothing.
  'Provides access to various maintenance functions.

  Dim numButtons As Integer
  Dim currButton As Integer
  numButtons = 3
  Do While True
    currButton = 1
    Dim dlgResult As String
    DlgCreate "Maintenance", numButtons + 4, 16
    DlgButton currButton * 2, 5, "&Carrier"
    currButton = currButton + 1
    DlgButton currButton * 2, 5, "&Exit"
    dlgResult = DlgDraw()
  
    If dlgResult = "Carrier" Then
      CS_Cswin.MaintainU
    ElseIf dlgResult = "Exit" Then
      Exit Do
    End If
  Loop
  
End Sub

Private Function GetPassword(correctPassword) As Boolean

  'Receives: Nothing.
  'Returns: True if user enters correct password, false otherwise.
  'Ask user for password, return true if matches gMaintenancePwd, false otherwise.
  
  Dim dlgResult As String
  
  XC2 = ""
  DlgCreate "Authorization", 10, 40
  DlgFrame 1, 1, 9.5, 39
  DlgText 4, 3, "Enter Password:"
  DlgPass 4, 16, XC2, 20
  DlgButton 8, 25, "&OK"
  DlgButton 8, 10, "E&xit"
  dlgResult = DlgDraw()
  
  If dlgResult = "OK" Then
    If XC2 = correctPassword Then
      GetPassword = True
    Else
      GetPassword = False
    End If
  Else
    GetPassword = False
  End If
  
End Function
