VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "LogFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Logging Class V1.00 July 26, 2008

Option Explicit

Private logFile As String

Public Sub Init(myFile As String, Optional myDir As String = "")

    'Receives: Name of log file, optionally directory for log file.
    'Returns: Nothing.
    'Initialize log file - set filename, optionally directory. Check that file isn't too big.
    
    'If no directory specified, put log in project path.
    If Len(myDir) = 0 Then
        myDir = ProjectDir()
    End If
            
    'Make sure that directory has trailing \
    If Right(RTrim(myDir), 1) = "\" Then
        logFile = myDir & myFile
    Else
        logFile = myDir & "\" & myFile
    End If

    Utils.LogCheck logFile, logSize, logBackups
    
End Sub

Public Sub PopAndLog(message As String, Optional title As String = "Message", Optional vbstyle As VbMsgBoxStyle = vbOKOnly)
    
    'Receives: Strings containing message to log, title for msgbox, style for msgbox.
    'Returns: Nothing.
    'Logs message to file then displays it.
    
    Host2.AppendLineTo logFile, DtoC(Date) & "," & Time & "," & message
    MsgBox message, vbstyle, title

End Sub

Public Sub Log(message As String)
    
    'Receives: String containing message to log.
    'Returns: Nothing.
    'Logs message to file.
    
    Host2.AppendLineTo logFile, DtoC(Date) & "," & Time & "," & message

End Sub

