Attribute VB_Name = "PURO_EWS"
Public puroDir As String
Public puroCfgXml As MSXML2.DOMDocument60
Public puroTestMode As Boolean
Public puroTransID As String
Public puroServer As String
Public puroShipmentXml As String
Public puroPreviousXml As String
Public puroResponseXml As String
Public puroTrackXml As String
Public puroRateXml As String
Public puroXml As String
Public puroServID As String
Public puroXmlRuleRq As String
Public puroXmlRuleRs As String
Public puroXmlRateRq As String
Public puroXmlRateRs As MSXML2.DOMDocument60
Public puroShipRqTxt As String
Public puroShipRqXml As MSXML2.DOMDocument60
Public puroShipRsTxt As String
Public puroShipRsXml As MSXML2.DOMDocument60

Public puroLabelRqTxt As String
Public puroLabelRqXml As MSXML2.DOMDocument60
Public puroLabelRsTxt As String
Public puroLabelRsXml As MSXML2.DOMDocument60

Dim puroStr0 As String, puroStr1 As String, puroStr2 As String, puroStr3 As String, puroStr4 As String, puroStr5 As String, puroStr6 As String, puroStr7 As String, puroStr8 As String, puroStr9 As String
Dim puroInt0 As Integer, puroInt1 As Integer, puroInt2 As Integer, puroInt3 As Integer, puroInt4 As Integer, puroInt5 As Integer, puroInt6 As Integer, puroInt7 As Integer, puroInt8 As Integer, puroInt9 As Integer
Dim puroDbl0 As Double, puroDbl1 As Double, puroDbl2 As Double, puroDbl3 As Double, puroDbl4 As Double, puroDbl5 As Double, puroDbl6 As Double, puroDbl7 As Double, puroDbl8 As Double, puroDbl9 As Double

Public Const MIDDOT As String = ""

Public lsxAutoProcXml As String

Sub Initialize()
    If Dir(CS32.ShipDir & "Logic", vbDirectory) = "" Then
        MkDir CS32.ShipDir & "Logic"
    End If
    
    puroDir = CS32.ShipDir & "Logic\Purolator-EWS"
    If Dir(puroDir, vbDirectory) = "" Then
        MkDir puroDir
    End If
    puroDir = puroDir & "\"
    
    If Dir(puroDir & "XML", vbDirectory) = "" Then
        MkDir puroDir & "XML"
    End If
    
    If Dir(puroDir & "Labels", vbDirectory) = "" Then
        MkDir puroDir & "Labels"
    End If
    
    If Dir(RunDir & "Watch", vbDirectory) = "" Then
        MkDir RunDir & "Watch"
    End If
    If Dir(RunDir & "Watch\Output", vbDirectory) = "" Then
        MkDir RunDir & "Watch\Output"
    End If
    
    If Not fExist(RunDir & "LseTools.exe") Then
        fCopy CS32.ShipDir & "Logic\LseTools.exe", RunDir & "LseTools.exe"
    End If
    
    Set puroCfgXml = New MSXML2.DOMDocument60
    puroCfgXml.async = False
    puroCfgXml.Load (puroDir & "PuroEwsCfg.xml")
End Sub

Sub ClearTrans()
    puroPreviousXml = ""
    puroShipmentXml = ""
    puroResponseXml = ""
End Sub

Private Sub CreateShipment()
    Dim csExpCount As Integer, csAccount As Integer
    csAccount = Val(CS32.GetVar("xACCOUNT"))
    csExpCount = Val(CS32.GetVar("xEXP_CNT"))
    
    puroStr1 = "/Purolator/Accounts/Account[@id='" & csAccount & "']/"
    puroTestMode = XmlReadXPath(puroCfgXml, puroStr1 & "@test") = "YES"
    
    If csExpCount > 1 Then
        'If lsxLogLvl > 2 Then
        '    lsxLogTxt = "Purolator multi-package: " + Str(csExpCount)
        '    LSX_LogWrite()
        'End If
        
        puroStr0 = Alltrim(Left(CS32.GetVar("xPKGID"), 20))
        puroStr1 = ""
        puroInt2 = 0
        Do While True
            puroInt0 = 0
            puroInt1 = 1
            Do While True
                puroStr2 = "/AutoProc[@PKGID='" + puroStr0 + "']/packageGroup[" + Str(puroInt1) + "]/qty/text()"
                'puroStr1 = XmlReadXPath(lsxAutoProcXml, puroStr2)
                'If lsxLogLvl > 2
                '    lsxLogTxt = "Purolator multi-package: " + puroStr2 + " => " + puroStr1
                '    LSX_LogWrite()
                'End If
                If KiEmpty(puroStr1) Then
                    Exit Do
                End If
                
                puroInt0 = puroInt0 + Val(puroStr1)
                puroInt1 = puroInt1 + 1
            Loop
            
            If csExpCount = puroInt0 Then
                Exit Do
            ElseIf puroInt2 > 0 Then
                puroStr3 = "You entered weights for " & Str(puroInt0) & " packages. " & vbLf & vbLf & _
                    MIDDOT & " Click 'Yes' to update the package count to " & Str(puroInt0) & "." & vbLf & _
                    MIDDOT & " Click 'No' to edit the packages."
                If MsgBox(puroStr3, vbYesNo, "Purolator Multiple Packages") = vbYes Then
                    csExpCount = puroInt0
                    CS32.SetVar "xEXP_CNT", Str(csExpCount)
                    Exit Do
                End If
            End If
    
            'LSX_AutoProcess()
            puroInt2 = puroInt2 + 1
        Loop
    End If
    
    puroStr1 = "/Purolator/Accounts/Account[@id='" & csAccount & "']/Sender/"
    
    puroShipmentXml = "<Shipment>" & vbLf & _
        vbTab + "<SenderInformation>" & vbLf & _
        vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Name", XmlReadXPath(puroCfgXml, puroStr1 & "Name/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Company", XmlReadXPath(puroCfgXml, puroStr1 & "Company/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Department", XmlReadXPath(puroCfgXml, puroStr1 & "Department/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetNumber", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Number/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetSuffix", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Suffix/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetName", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Name/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetType", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Type/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetDirection", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Direction/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Suite", XmlReadXPath(puroCfgXml, puroStr1 & "Suite/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Floor", XmlReadXPath(puroCfgXml, puroStr1 & "Floor/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetAddress2", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress2/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetAddress3", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress3/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("City", XmlReadXPath(puroCfgXml, puroStr1 & "City/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Province", XmlReadXPath(puroCfgXml, puroStr1 & "Province/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Country", XmlReadXPath(puroCfgXml, puroStr1 & "Country/text()")) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("PostalCode", XmlReadXPath(puroCfgXml, puroStr1 & "PostalCode/text()")) & vbLf & _
        vbTab & vbTab & vbTab & "<PhoneNumber>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("CountryCode", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/CountryCode/text()")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("AreaCode", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/AreaCode/text()")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Phone", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/Phone/text()")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Extension", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/Extension/text()")) & vbLf & _
        vbTab & vbTab & vbTab & "</PhoneNumber>" & vbLf
        
    puroShipmentXml = puroShipmentXml & _
        vbTab & vbTab & vbTab & "<FaxNumber>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("CountryCode", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/CountryCode/text()")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("AreaCode", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/AreaCode/text()")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Phone", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/Phone/text()")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Extension", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/Extension/text()")) & vbLf & _
        vbTab & vbTab & vbTab & "</FaxNumber>" & vbLf & _
        vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & "</SenderInformation>" & vbLf & _
        vbTab & "<ReceiverInformation>" & vbLf & _
        vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Name", Alltrim(Left(CS32.GetVar("xSHIPTO3"), 30))) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Company", Alltrim(Left(CS32.GetVar("xSHIPTO1"), 30))) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Department", "") & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetNumber", "") & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetName", Alltrim(CS32.GetVar("xSHIPTO4"))) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetAddress2", Alltrim(Left(CS32.GetVar("xSHIPTO5"), 25))) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("StreetAddress3", Alltrim(Left(CS32.GetVar("xSHIPTO6"), 25))) & vbLf
        
    puroStr1 = Alltrim(CS32.GetVar("xSHIPTO7"))
    puroStr2 = ""
    puroInt1 = InStrRev(puroStr1, " ")
    If puroInt1 > 0 Then
        puroStr2 = SubStr(puroStr1, puroInt1 + 1)
        puroStr1 = Alltrim(Left(puroStr1, puroInt1 - 1))
    End If
    
    puroShipmentXml = puroShipmentXml & _
        vbTab & vbTab & vbTab & XmlWriteTag("City", puroStr1) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Province", puroStr2) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Country", "CA") & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("PostalCode", Alltrim(CS32.GetVar("xZIP"))) & vbLf & _
        vbTab & vbTab & vbTab & "<PhoneNumber>" & vbLf
        
    puroStr1 = Alltrim(CS32.GetVar("xPHONE"))
    puroStr1 = Validated(puroStr1, 48, 57, 0, 0, 0, 0)
    If At("1", puroStr1) = 1 Then
        puroStr1 = SubStr(puroStr1, 2)
    End If
    
    puroShipmentXml = puroShipmentXml & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("CountryCode", "1") & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("AreaCode", Left(puroStr1, 3)) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Phone", SubStr(puroStr1, 4, 7)) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Extension", SubStr(puroStr1, 11)) & vbLf & _
        vbTab & vbTab & vbTab & "</PhoneNumber>" & vbLf & _
        vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & "</ReceiverInformation>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<PackageInformation>" & vbLf
        
    puroServID = XmlReadXPath(puroCfgXml, "/Purolator/Services/Service[@intcode='" + Alltrim(CS32.GetVar("xINTCODE")) + "']/text()")
    
    puroShipmentXml = puroShipmentXml & _
        vbTab & vbTab & XmlWriteTag("ServiceID", XmlReadXPath(puroCfgXml, "/Purolator/Services/Service[@intcode='" + Alltrim(CS32.GetVar("xINTCODE")) + "']/text()")) & vbLf & _
        vbTab & vbTab & XmlWriteTag("Description", "Description") & vbLf
    
    puroStr1 = ""
    puroStr2 = ""
    puroStr3 = ""
    If csExpCount = 1 Then
        puroDbl0 = Val(CS32.GetVar("xACT_WGT"))
        puroStr3 = Alltrim(Str(Max(puroDbl0, 1), 10, 4))
        Do While (Right(puroStr3, 1) = "0")
            puroStr3 = Left(puroStr3, Len(puroStr3) - 1)
        Loop
        If (Right(puroStr3, 1) = ".") Then
            puroStr3 = Left(puroStr3, Len(puroStr3) - 1)
        End If
        
        puroStr1 = puroStr1 & _
            vbTab & vbTab & vbTab & "<Piece>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<Weight>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", puroStr3) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("WeightUnit", "lb") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</Weight>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<Length>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", Alltrim(CS32.GetVar("xDIM_LENGTH"))) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("DimensionUnit", "in") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</Length>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<Width>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", Alltrim(CS32.GetVar("xDIM_WIDTH"))) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("DimensionUnit", "in") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</Width>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<Height>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", Alltrim(CS32.GetVar("xDIM_HEIGHT"))) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("DimensionUnit", "in") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</Height>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<Options xsi:nil=""true"" />" & vbLf & _
            vbTab & vbTab & vbTab & "</Piece>" & vbLf
    Else
        puroDbl0 = 0
        puroInt1 = 1
        Do While True
            'puroStr3 = XmlReadXPath(lsxAutoProcXml, "/AutoProc/packageGroup[" + Str(puroInt1) + "]/qty/text()")
            If KiEmpty(puroStr3) Then
                Exit Do
            End If
    
            puroInt2 = Val(puroStr3)
            puroDbl3 = Val(XmlReadXPathFromText(lsxAutoProcXml, "/AutoProc/packageGroup[" + Str(puroInt1) + "]/weight/text()"))
            puroInt4 = 1
            Do While puroInt4 <= puroInt2
                puroStr3 = Str(Max(puroDbl3, 1), 0, 4)
                Do While (Right(puroStr3, 1) = "0")
                    puroStr3 = Left(puroStr3, Len(puroStr3) - 1)
                Loop
                If (Right(puroStr3, 1) = ".") Then
                    puroStr3 = Left(puroStr3, Len(puroStr3) - 1)
                End If
                
                puroStr1 = puroStr1 & _
                    vbTab & vbTab & vbTab & "<Piece>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "<Weight>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", puroStr3) & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("WeightUnit", "lb") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "</Weight>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "<Length>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", "0") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("DimensionUnit", "in") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "</Length>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "<Width>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", "0") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("DimensionUnit", "in") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "</Width>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "<Height>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", "0") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("DimensionUnit", "in") & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "</Height>" & vbLf & _
                    vbTab & vbTab & vbTab & vbTab & "<Options xsi:nil=""true"" />" & vbLf & _
                    vbTab & vbTab & vbTab & "</Piece>" & vbLf
                
                puroDbl0 = puroDbl0 + puroDbl3
                puroInt4 = puroInt5 + 1
            Loop
            
            puroInt1 = puroInt1 + 1
        Loop
    End If
    
    puroStr0 = CS32.GetVar("xUSE_DCS")
    puroStr2 = ""
    If puroStr0 = "R" Then
        puroStr2 = "ResidentialSignatureDomestic"
    ElseIf puroStr0 = "O" Then
        puroStr2 = "OriginSignatureNotRequired"
    End If
    
    'TotalWeight and TotalPieces must be before the PiecesInformation in the XML.
    puroShipmentXml = puroShipmentXml & _
        vbTab & vbTab & "<TotalWeight>" & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("Value", Str(Roundup(puroDbl0, 1))) & vbLf & _
        vbTab & vbTab & vbTab & XmlWriteTag("WeightUnit", "lb") & vbLf & _
        vbTab & vbTab & "</TotalWeight>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("TotalPieces", Str(csExpCount)) & vbLf & _
        vbTab & vbTab & "<PiecesInformation>" & vbLf & _
        puroStr1 & _
        vbTab & vbTab & "</PiecesInformation>" & vbLf & _
        vbTab & vbTab & "<OptionsInformation>" & vbLf & _
        vbTab & vbTab & vbTab & "<Options>" & vbLf
    
    If Not KiEmpty(puroStr2) Then
        puroShipmentXml = puroShipmentXml & _
            vbTab & vbTab & vbTab & vbTab & "<OptionIDValuePair>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("ID", puroStr2) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", "true") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</OptionIDValuePair>" & vbLf
    End If
    
    puroDbl0 = Val(CS32.GetVar("xCOD_AMT"))
    If puroDbl0 > 0 Then
        puroShipmentXml = puroShipmentXml & _
            vbTab & vbTab & vbTab & vbTab & "<OptionIDValuePair>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("ID", "ExpressCheque") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", "true") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</OptionIDValuePair>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<OptionIDValuePair>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("ID", "ExpressChequeAmount") & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", Alltrim(Str(puroDbl0, 8, 2))) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</OptionIDValuePair>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "<OptionIDValuePair>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("ID", "ExpressChequeMethodOfPayment") & vbLf
    
        puroStr1 = CS32.GetVar("xCOD_FLAG")
        If puroStr1 = "P" Then
            puroStr2 = "PostDatedCheque"
        ElseIf puroStr1 = "C" Then
            puroStr2 = "CertifiedCheque"
        ElseIf puroStr1 = "M" Then
            puroStr2 = "MoneyOrder"
        ElseIf puroStr1 = "B" Then
            puroStr2 = "BankDraft"
        Else
            CS32.SetVar "xCOD_FLAG", "Y"
            puroStr2 = "Cheque"
        End If
        puroShipmentXml = puroShipmentXml & _
            vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Value", puroStr2) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & "</OptionIDValuePair>" & vbLf
    End If
    puroShipmentXml = puroShipmentXml & vbTab & vbTab & vbTab & "</Options>" & vbLf
    
    If puroDbl0 > 0 Then
        puroStr1 = "Purolator/Accounts/Account[@id='" + csAccount + "']/"
        If XmlReadXPath(puroCfgXml, puroStr1 & "ExpressChequeAddress/@use_sender") = "Y" Then
            puroStr1 = puroStr1 & "Sender/"
        Else
            puroStr1 = puroStr1 & "ExpressChequeAddress/"
        End If
    
        puroShipmentXml = puroShipmentXml & _
            vbTab & vbTab & vbTab & "<ExpressChequeAddress>" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Name", XmlReadXPath(puroCfgXml, puroStr1 & "Name/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Company", XmlReadXPath(puroCfgXml, puroStr1 & "Company/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Department", XmlReadXPath(puroCfgXml, puroStr1 & "Department/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetNumber", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Number/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetSuffix", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Suffix/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetName", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Name/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetType", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Type/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetDirection", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress1/Direction/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Suite", XmlReadXPath(puroCfgXml, puroStr1 & "Suite/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Floor", XmlReadXPath(puroCfgXml, puroStr1 & "Floor/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetAddress2", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress2/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("StreetAddress3", XmlReadXPath(puroCfgXml, puroStr1 & "StreetAddress3/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("City", XmlReadXPath(puroCfgXml, puroStr1 & "City/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Province", XmlReadXPath(puroCfgXml, puroStr1 & "Province/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Country", XmlReadXPath(puroCfgXml, puroStr1 & "Country/text()")) & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("PostalCode", XmlReadXPath(puroCfgXml, puroStr1 & "PostalCode/text()")) & vbLf & _
            vbTab & vbTab & vbTab & "<PhoneNumber>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("CountryCode", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/CountryCode/text()")) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("AreaCode", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/AreaCode/text()")) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Phone", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/Phone/text()")) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Extension", XmlReadXPath(puroCfgXml, puroStr1 & "PhoneNumber/Extension/text()")) & vbLf & _
            vbTab & vbTab & vbTab & "</PhoneNumber>" & vbLf
            
        puroShipmentXml = puroShipmentXml & _
            vbTab & vbTab & vbTab & "<FaxNumber>" & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("CountryCode", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/CountryCode/text()")) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("AreaCode", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/AreaCode/text()")) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Phone", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/Phone/text()")) & vbLf & _
            vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Extension", XmlReadXPath(puroCfgXml, puroStr1 & "FaxNumber/Extension/text()")) & vbLf & _
            vbTab & vbTab & vbTab & "</FaxNumber>" & vbLf & _
            vbTab & vbTab & vbTab & "</ExpressChequeAddress>" & vbLf
    Else
        puroShipmentXml = puroShipmentXml & vbTab & vbTab & vbTab & "<ExpressChequeAddress xsi:nil=""true"" />" & vbLf
    End If
    puroShipmentXml = puroShipmentXml & _
        vbTab & vbTab & "</OptionsInformation>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</PackageInformation>" & vbLf & _
        vbTab & "<InternationalInformation xsi:nil=""true"" />" & vbLf & _
        vbTab & "<ReturnShipmentInformation xsi:nil=""true"" />" & vbLf
    
    puroStr1 = "9999999999"
    If Not puroTestMode Then
        puroStr1 = XmlReadXPath(puroCfgXml, "/Purolator/Accounts/Account[@id='" & csAccount & "']/AccountNo/text()")
    End If
    puroStr2 = "Sender"
    puroStr3 = CS32.GetVar("xPAY_FLAG")
    puroStr4 = puroStr1
    If puroStr3 = "2" Then
        puroStr2 = "Receiver"
        puroStr4 = Alltrim(CS32.GetVar("xPAY_ACCT"))
    ElseIf puroStr3 = "3" Then
        puroStr2 = "ThirdParty"
        puroStr4 = Alltrim(CS32.GetVar("xPAY_ACCT"))
    End If
    
    puroShipmentXml = puroShipmentXml & _
        vbTab & "<PaymentInformation>" & vbLf & _
        vbTab & vbTab & XmlWriteTag("PaymentType", puroStr2) & vbLf & _
        vbTab & vbTab & XmlWriteTag("RegisteredAccountNumber", puroStr1) & vbLf & _
        vbTab & vbTab & XmlWriteTag("BillingAccountNumber", puroStr4) & vbLf & _
        vbTab & vbTab & "<CreditCardInformation xsi:nil=""true"" />" & vbLf & _
        vbTab & "</PaymentInformation>" & vbLf & _
    vbTab & "<PickupInformation>" & vbLf & _
    vbTab & vbTab & XmlWriteTag("PickupType", "PreScheduled") & vbLf & _
    vbTab & "</PickupInformation>" & vbLf & _
    vbTab & "<TrackingReferenceInformation>" & vbLf & _
    vbTab & vbTab & XmlWriteTag("Reference1", Alltrim(CS32.GetVar("xPKGREFD1"))) & vbLf & _
    vbTab & vbTab & XmlWriteTag("Reference2", Alltrim(CS32.GetVar("xPKGREFD2"))) & vbLf & _
    vbTab & vbTab & XmlWriteTag("Reference3", Alltrim(CS32.GetVar("xPKGREFD3"))) & vbLf & _
    vbTab & vbTab & XmlWriteTag("Reference4", Alltrim(CS32.GetVar("xPKGREFD4"))) & vbLf & _
    vbTab & "</TrackingReferenceInformation>" & vbLf & _
    vbTab & "<OtherInformation xsi:nil=""true"" />" & vbLf & _
    "</Shipment>" & vbLf
End Sub

Sub AfterCarrierLookup()
    
    lsxSpSvcListID = "PURO"
    
    'fErase (lsxTempDir + "SpSvc-" + lsxSpSvcListID + ".xml")
    
    'str1 = Alltrim(CS32.GetVar("xPAY_ACCT"))
    'If Val(CS32.GetVar("xUSE_PAY")) > 1 And KiEmpty(str1) Then
    '    lsxSpSvcPromptText = "Payment Account"
    '    lsxSpSvcPromptValue = str1
    '    WinOpen (winLSXSpSvcEdit)
    '    CS32.SetVar "xPAY_ACCT", lsxSpSvcPromptValue
    '    If KiEmpty(lsxSpSvcPromptValue) Then
    '        CS32.SetVar "xUSE_PAY", "1"
    '    End If
    'End If
    
    If XmlReadXPath(puroCfgXml, "/Purolator/Workstations/Workstation[@type='" & Upper(Alltrim(CS32.GetVar("xWORKSTATION"))) & "']/Settings/@getoptions") <> "N" Then
    '    PURO_GetOptions
    End If
End Sub

Sub Rate()
    If Left(CS32.GetVar("xINTCODE"), 2) <> "XP" Then
        Exit Sub
    End If
    
    If puroCfgXml Is Nothing Then
        Initialize
    End If
    
    Dim csAccount As Integer, csOrdCount As Integer
    csAccount = Val(CS32.GetVar("xACCOUNT"))
    csOrdCount = Val(CS32.GetVar("xORD_CNT"))
    
    If csOrdCount = 0 Then
        'Only create new rate request once for this package, unless something has changed.
        puroPreviousXml = puroShipmentXml
        CreateShipment
        If puroShipmentXml <> puroPreviousXml And Val(CS32.GetVar("xUSE_PAY")) <= 1 Then
            puroTransID = "Rate-" + Alltrim(Left(CS32.GetVar("xPKGID"), 20))
    
            puroXmlRateRq = "" & _
                "<GetFullEstimateRequest xmlns=""http://purolator.com/pws/datatypes/v1"">" + vbLf & _
                puroShipmentXml & _
                vbTab + XmlWriteTag("ShowAlternativeServicesIndicator", "false") + vbLf & _
                "</GetFullEstimateRequest>" + vbLf

            puroXml = "<?xml version=""1.0"" encoding=""utf-8""?>" + vbLf & _
                "<soap:Envelope xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">" + vbLf & _
                vbTab + "<soap:Header>" + vbLf & _
                vbTab + vbTab + "<RequestContext xmlns=""http://purolator.com/pws/datatypes/v1"">" + vbLf & _
                vbTab + vbTab + vbTab + XmlWriteTag("Version", "1.0") + vbLf & _
                vbTab + vbTab + vbTab + XmlWriteTag("Language", "en") + vbLf & _
                vbTab + vbTab + vbTab + XmlWriteTag("GroupID", "111") + vbLf & _
                vbTab + vbTab + vbTab + XmlWriteTag("RequestReference", Alltrim(CS32.GetVar("xPKGID"))) + vbLf & _
                vbTab + vbTab + "</RequestContext>" + vbLf & _
                vbTab + "</soap:Header>" + vbLf & _
                vbTab + "<soap:Body>" + vbLf & _
                puroXmlRateRq & _
                vbTab + "</soap:Body>" + vbLf & _
                "</soap:Envelope>" + vbLf
            
            'Save file
            puroStr1 = ""
            Do While fExist(puroDir & "XML\" & puroTransID & puroStr1 & ".xml")
                puroStr1 = Alltrim(Str(Val(puroStr1) - 1))
            Loop
            puroTransID = puroTransID & puroStr1
            
            puroStr1 = SendRequest(puroXml, "rate", puroTransID, csAccount)
            
            puroInt1 = InStr(puroStr1, ">")
            puroInt2 = InStr(puroStr1, " ")
            If puroInt2 > 1 And puroInt2 < puroInt1 Then
                puroStr1 = Left(puroStr1, puroInt2 - 1) & SubStr(puroStr1, puroInt1)
            End If
            puroStr1 = StrTran(puroStr1, "i:", "")

            Set puroXmlRateRs = New MSXML2.DOMDocument60
            puroXmlRateRs.async = False
            puroXmlRateRs.loadXML puroStr1

        End If
        
        'Check for errors in response.
        puroStr1 = Alltrim(XmlReadXPath(puroXmlRateRs, "/GetFullEstimateResponse/ResponseInformation/Errors/Error/Code/text()"))
        If Not KiEmpty(puroStr1) Then
            puroStr2 = puroStr1
            puroStr3 = XmlReadXPath(puroXmlRateRs, "/GetFullEstimateResponse/ResponseInformation/Errors/Error/Description/text()")
            If puroStr2 = "1100491" Then
                puroStr3 = "Invalid service (" & puroServID & ")"
            ElseIf puroStr2 = "1100674" Then
                If InStr(Upper(puroStr3), "POSTAL CODE") = 1 And InStr(Upper(puroStr3), "IS ONLY VALID FOR") > 1 Then
                    puroStr4 = Alltrim(SubToken(Upper(puroStr3), 2, "IS ONLY VALID FOR"))
                    puroStr5 = Left(Alltrim(SubToken(puroStr4, 2, ",")), 2)
                    puroStr4 = Alltrim(SubToken(puroStr4, 1, ",")) & " " & puroStr5
                    If (XmlReadXPath(puroCfgXml, "/Purolator/Accounts/Account[@id='" & csAcct & "']/Settings/@AutoUpdateCityProvince") = "Y") Then
                        'lsxLogTxt = "Purolator AutoUpdateCityProvince: Change '" & Alltrim(CS32.GetVar("xSHIPTO7")) & "' to '" & puroStr4 & "'"
                        'LSX_LogWrite()
                        CS32.SetVar "xSHIPTO7", puroStr4
                        Rate
                        Exit Sub
                    ElseIf MsgBox(puroStr3 & vbLf & vbLf & "Would you like to change the city, state/province from """ & Alltrim(CS32.GetVar("xSHIPTO7")) & """ to """ & puroStr4 & """?", vbYesNo, "Purolator Error") = vbYes Then
                        'lsxLogTxt = "Purolator update City/Province (accepted): Change "" & Alltrim(CS32.GetVar("xSHIPTO7")) & "" to "" & puroStr4 & """
                        'LSX_LogWrite()
                        CS32.SetVar "xSHIPTO7", puroStr4
                        Rate
                        Exit Sub
                    End If
                End If
            End If
    
            CS32.SetVar "xERROR", puroStr3
        End If
    End If
    
    'Read in rate results.
    puroStr1 = "/GetFullEstimateResponse/ShipmentEstimates/ShipmentEstimate[1]"
    kiDebug (puroStr1)
    
    'Base & total price.
    puroDbl0 = Val(XmlReadXPath(puroXmlRateRs, puroStr1 & "/BasePrice/text()"))
    CS32.SetVar "xSHP_CHG", Alltrim(Str(puroDbl0, 8, 2))
    puroDbl0 = Val(XmlReadXPath(puroXmlRateRs, puroStr1 & "/TotalPrice/text()"))
    CS32.SetVar "xTOT_CHG", Alltrim(Str(puroDbl0, 8, 2))
    
    'Loop to read in all surcharges.
    puroInt0 = 1
    puroDbl2 = 0
    Do While True
        puroStr0 = "/GetFullEstimateResponse/ShipmentEstimates/ShipmentEstimate[1]/Surcharges/Surcharge[" & puroInt0 & "]"
        puroStr2 = XmlReadXPath(puroXmlRateRs, puroStr0 & "/Amount/text()")
        If KiEmpty(puroStr2) Then
            Exit Do
        End If
        kiDebug (puroStr2)
            
        puroDbl1 = Val(puroStr2)
        If puroDbl1 > 0 Then
            If XmlReadXPath(puroXmlRateRs, puroStr0 & "/Type/text()") = "Fuel" Then
                CS32.SetVar "xUSE_FSC", "Y"
                CS32.SetVar "xFSC_CHG", Alltrim(Str(puroDbl1, 8, 2))
            Else
            'Running total of "other" charges.
            puroDbl2 = puroDbl2 + puroDbl1
            End If
        End If
        puroInt0 = puroInt0 + 1
    Loop
    
    'Store "other" charges in CVD_CHG.
    puroStr0 = ""
    If puroDbl2 > 0 Then
        puroStr0 = "Y"
    End If
    CS32.SetVar "xCVD_CHG", Alltrim(Str(puroDbl2, 8, 2))
    CS32.SetVar "xUSE_CVD", puroStr0
    
    'Loop to read in taxes.
    puroInt0 = 1
    puroDbl2 = 0
    Do While True
        puroStr0 = "/GetFullEstimateResponse/ShipmentEstimates/ShipmentEstimate[1]/Taxes/Tax[" & puroInt0 & "]"
        puroStr2 = XmlReadXPath(puroXmlRateRs, puroStr0 & "/Amount/text()")
        If KiEmpty(puroStr2) Then
            Exit Do
        End If
        kiDebug (puroStr2)
        
        puroDbl1 = Val(puroStr2)
        If puroDbl1 > 0 Then
        'Running total for all taxes.
            puroDbl2 = puroDbl2 + puroDbl1
        End If
        puroInt0 = puroInt0 + 1
    Loop
    'Store taxes in DDP_CHG.
    puroStr0 = ""
    If puroDbl2 > 0 Then
        puroStr0 = "Y"
    End If
    CS32.SetVar "xDDP_CHG", Alltrim(Str(puroDbl2, 8, 2))
    CS32.SetVar "xUSE_DDP", puroStr0
    
    'Loop to read in Option prices.
    puroInt0 = 1
    puroDbl2 = 0
    Do While True
        puroStr0 = "/GetFullEstimateResponse/ShipmentEstimates/ShipmentEstimate[1]/OptionPrices/OptionPrice[" & puroInt0 & "]"
        puroStr2 = XmlReadXPath(puroXmlRateRs, puroStr0 & "/Amount/text()")
        If KiEmpty(puroStr2) Then
            Exit Do
        End If
        kiDebug (puroStr2)
            
        puroDbl1 = Val(puroStr2)
        If puroDbl1 > 0 Then
            If XmlReadXPath(puroXmlRateRs, puroStr0 & "/ID/text()") = "ExpressCheque" Then
                CS32.SetVar "xCOD_CHG", Alltrim(Str(puroDbl1, 8, 2))
            Else
            'Running total of "other" charges.
            puroDbl2 = puroDbl2 + puroDbl1
            End If
        End If
        puroInt0 = puroInt0 + 1
    Loop
    
    'Store "other" charges in AOD_CHG.
    puroStr0 = ""
    If puroDbl2 > 0 Then
        puroStr0 = "Y"
    End If
    CS32.SetVar "xCVP_CHG", Alltrim(Str(puroDbl2, 8, 2))
    CS32.SetVar "xUSE_CVP", puroStr0

End Sub

Sub RateDisplay()
    If Left(CS32.GetVar("xINTCODE"), 2) <> "XP" Then
        Exit Sub
    End If
    
    CS32.SetVar "RightMiddle", ""
    
    CS32.SetVar "RightMiddle", PadR("Shipping", 19) + Str(Val(CS32.GetVar("xSHP_CHG")), 8, 2)
    
    str1 = Alltrim(CS32.GetVar("xUSE_COD"))
    If Not (KiEmpty(str1) Or str1 = "N") Then
        CS32.SetVar "RightMiddle", PadR("Express Cheque", 19) + Str(Val(CS32.GetVar("xCOD_CHG")), 8, 2)
    End If
    If CS32.GetVar("xUSE_FSC") = "Y" Then
        CS32.SetVar "RightMiddle", PadR("Fuel Surcharge", 19) + Str(Val(CS32.GetVar("xFSC_CHG")), 8, 2)
    End If
    If CS32.GetVar("xUSE_DDP") = "Y" Then
        CS32.SetVar "RightMiddle", PadR("Taxes", 19) + Str(Val(CS32.GetVar("xDDP_CHG")), 8, 2)
    End If
    If CS32.GetVar("xUSE_CVD") = "Y" Then
        CS32.SetVar "RightMiddle", PadR("Other Surcharge", 19) + Str(Val(CS32.GetVar("xCVD_CHG")), 8, 2)
    End If
    If CS32.GetVar("xUSE_CVP") = "Y" Then
        CS32.SetVar "RightMiddle", PadR("Other Options", 19) + Str(Val(CS32.GetVar("xCVP_CHG")), 8, 2)
    End If
    
    'Add an entry for the premium delivery, for visual confirmation.
    puroStr0 = CS32.GetVar("xUSE_HEP")
    If puroStr0 <> "N" Then
        CS32.SetVar "RightMiddle", " "
        puroStr1 = " "
        If puroStr0 = "9" Then
            puroStr1 = "9AM Delivery"
        ElseIf puroStr0 = "X" Then
            puroStr1 = "10:30AM Delivery"
        ElseIf puroStr0 = "E" Then
            puroStr1 = "Evening Delivery"
        End If
        CS32.SetVar "RightMiddle", puroStr1
    End If
End Sub


Public Sub Record()
    If Left(CS32.GetVar("xINTCODE"), 2) <> "XP" Then
        Exit Sub
    End If
    
    Dim csAccount As Integer
    Dim csOrdCount As Integer
    Dim csExpCount As Integer
    
    'Prevent CS from printing Ratrix label.
    CS32.SetVar "xUSE_LABEL", "000000"
    
    csAccount = Val(CS32.GetVar("xACCOUNT"))
    csOrdCount = Val(CS32.GetVar("xORD_CNT"))
    csExpCount = Val(CS32.GetVar("xEXP_CNT"))
    If csOrdCount = 0 Then
        puroTransID = "Ship-" + Alltrim(Left(CS32.GetVar("xPKGID"), 20))
    
        puroShipRqTxt = "<CreateShipmentRequest xmlns=""http://purolator.com/pws/datatypes/v1"">" & vbLf & _
                    puroShipmentXml & _
                    vbTab & XmlWriteTag("PrinterType", "Thermal") & vbLf & _
                    "</CreateShipmentRequest>" & vbLf
        
        'Create xml.
        puroStr0 = "<?xml version=""1.0"" encoding=""utf-8""?>" + vbLf & _
            "<soap:Envelope xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">" & vbLf & _
            vbTab & "<soap:Header>" & vbLf & _
            vbTab & vbTab & "<RequestContext xmlns=""http://purolator.com/pws/datatypes/v1"">" & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Version", "1.2") & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("Language", "en") & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("GroupID", "") & vbLf & _
            vbTab & vbTab & vbTab & XmlWriteTag("RequestReference", Alltrim(CS32.GetVar("xPKGID"))) & vbLf & _
            vbTab & vbTab & "</RequestContext>" & vbLf & _
            vbTab & "</soap:Header>" & vbLf & _
            vbTab & "<soap:Body>" & vbLf & _
            puroShipRqTxt & vbLf & _
            vbTab & "</soap:Body>" & vbLf & _
            "</soap:Envelope>" & vbLf

        puroShipRqTxt = puroStr0
        puroShipRsTxt = SendRequest(puroShipRqTxt, "ship", puroTransID, csAccount)
        
        puroInt1 = InStr(puroShipRsTxt, ">")
        puroInt2 = InStr(puroShipRsTxt, " ")
        If puroInt2 > 1 And puroInt2 < puroInt1 Then
            puroShipRsTxt = Left(puroShipRsTxt, puroInt2 - 1) & SubStr(puroShipRsTxt, puroInt1)
        End If
        puroShipRsTxt = StrTran(puroShipRsTxt, "i:", "")

        Set puroShipRsXml = New MSXML2.DOMDocument60
        puroShipRsXml.async = False
        puroShipRsXml.loadXML puroShipRsTxt
        
        puroStr2 = Alltrim(XmlReadXPath(puroShipRsXml, "/CreateShipmentResponse/ResponseInformation/Errors/Error/Code/text()"))
        If Not KiEmpty(puroStr2) Then
            'Send error details to Clippership.
            puroStr3 = Alltrim(XmlReadXPath(puroShipRsXml, "/CreateShipmentResponse/ResponseInformation/Errors/Error/Description/text()"))
            puroStr4 = Alltrim(XmlReadXPath(puroShipRsXml, "/CreateShipmentResponse/ResponseInformation/Errors/Error/AdditionalInformation/text()"))
            CS32.SetVar "xERROR", puroStr3 & " (" & puroStr4 & " " & puroStr2 & ")"
        Else
            Dim puroTrackNo As String
            
            puroTrackNo = Alltrim(XmlReadXPath(puroShipRsXml, "/CreateShipmentResponse/ShipmentPIN/Value/text()"))
            CS32.SetVar "xTRACK_NO", puroTrackNo
            
            puroTransID = "GetLabel-" + puroTrackNo
            
            puroLabelRqTxt = "<soapenv:Envelope xmlns:soapenv=""http://schemas.xmlsoap.org/soap/envelope/"" xmlns:v1=""http://purolator.com/pws/datatypes/v1"">" & vbLf & _
                vbTab & "<soapenv:Header>" & vbLf & _
                vbTab & vbTab & "<v1:RequestContext>" & vbLf & _
                vbTab & vbTab & vbTab & "<v1:Version>1.0</v1:Version>" & vbLf & _
                vbTab & vbTab & vbTab & "<v1:Language>en</v1:Language>" & vbLf & _
                vbTab & vbTab & vbTab & "<v1:GroupID>11</v1:GroupID>" & vbLf & _
                vbTab & vbTab & vbTab & "<v1:RequestReference>UserRef</v1:RequestReference>" & vbLf & _
                vbTab & vbTab & "</v1:RequestContext>" & vbLf & _
                vbTab & "</soapenv:Header>" & vbLf & _
                vbTab & "<soapenv:Body>" & vbLf & _
                vbTab & vbTab & "<v1:GetDocumentsRequest>" & vbLf & _
                vbTab & vbTab & vbTab & "<v1:DocumentCriterium>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & "<v1:DocumentCriteria>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & vbTab & "<v1:PIN>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("v1:Value", puroTrackNo) & vbLf & _
                vbTab & vbTab & vbTab & vbTab & vbTab & "</v1:PIN>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & vbTab & "<v1:DocumentTypes>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<v1:DocumentType>DomesticBillOfLadingThermal</v1:DocumentType>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & vbTab & "</v1:DocumentTypes>" & vbLf & _
                vbTab & vbTab & vbTab & vbTab & "</v1:DocumentCriteria>" & vbLf & _
                vbTab & vbTab & vbTab & "</v1:DocumentCriterium>" & vbLf & _
                vbTab & vbTab & "</v1:GetDocumentsRequest>" & vbLf & _
                vbTab & "</soapenv:Body>" & vbLf & _
                "</soapenv:Envelope>" & vbLf
                
            puroLabelRsTxt = SendRequest(puroLabelRqTxt, "getlabel", puroTransID, csAccount)
            
            puroInt1 = InStr(puroLabelRsTxt, ">")
            puroInt2 = InStr(puroLabelRsTxt, " ")
            If puroInt2 > 1 And puroInt2 < puroInt1 Then
                puroLabelRsTxt = Left(puroLabelRsTxt, puroInt2 - 1) & SubStr(puroLabelRsTxt, puroInt1)
            End If
            puroLabelRsTxt = StrTran(puroLabelRsTxt, "i:", "")

            Set puroLabelRsXml = New MSXML2.DOMDocument60
            puroLabelRsXml.async = False
            puroLabelRsXml.loadXML puroLabelRsTxt
        
            puroInt1 = 0
            'Do While True
                puroInt1 = puroInt1 + 1

                WinExec "LseTools.exe"
                
                'Get URL from response.
                puroStr4 = XmlReadXPath(puroLabelRsXml, "/GetDocumentsResponse/Documents/Document/DocumentDetails/DocumentDetail/URL/text()")
                puroStr5 = puroDir + "Labels\" + puroTrackNo + ".pdf"
                'If lsxLoglvl >= 1
                '    lsxLogTxt = "PuroAPI label download attempt " + Str(num1) + ": " + str4 + " => " + str5
                '    LSX_LogWrite()
                'End If

                puroStr1 = "" & _
                    "<getpurodoc>" & vbLf & _
                    vbTab & XmlWriteTag("downloadpath", puroStr4) & vbLf & _
                    vbTab & XmlWriteTag("savepath", puroStr5) & vbLf & _
                    vbTab & XmlWriteTag("autoprintexe", RunDir + "FRP\FoxitReaderPortable.exe") & vbLf & _
                    vbTab & XmlWriteTag("autoprintargs", "/t """ & str5 & """ """ & XmlReadXPath(puroCfgXml, "/Purolator/Workstations/Workstation[@type=""" & Upper(Alltrim(CS32.GetVar("xWORKSTATION"))) & """]/LabelPrinter/text()") & """") & vbLf & _
                    "</getpurodoc>" & vbLf
                    
                'Debug(str1)
                'If lsxLogLvl >= 5
                '    lsxLogTxt = "PuroAPI label download request: " + str1
                '    LSX_LogWrite()
                'End If
                
                puroStr2 = XmlReadXPath(puroCfgXml, "/Purolator/Settings/LabelDownloadDelay/text()")
                If KiEmpty(puroStr2) Then
                    puroStr2 = "0.5"
                End If
                puroDbl0 = Val(puroStr2)
                Delay puroDbl0
                
                puroStr2 = "PuroGetDoc" & puroTrackNo & ".xml"
                
                puroStr6 = puroStr5
                puroInt6 = fErase(puroStr6)
                'If lsxLogLvl >= 5
                '    lsxLogTxt = "Delete " + str6 + ": " + Str(num6)
                '    LSX_LogWrite()
                'End If

                puroStr6 = RunDir & "Watch\" & puroStr2
                puroInt6 = fErase(puroStr6)
                'If lsxLogLvl >= 5
                '    lsxLogTxt = "Delete " + str6 + ": " + Str(num6)
                '    LSX_LogWrite()
                'End If

                puroStr6 = RunDir & "Watch\Output\" & puroStr2
                puroInt6 = fErase(puroStr6)
                'If lsxLogLvl >= 5
                '    lsxLogTxt = "Delete " + str6 + ": " + Str(num6)
                '    LSX_LogWrite()
                'End If
                
                Delay 1

                puroInt1 = FreeFile
                Open RunDir & "Watch\" & puroStr2 For Output As #puroInt1
                Print #puroInt1, puroStr1
                Close #puroInt1
                
                puroDbl1 = 0 'Counter
                puroDbl2 = 0.05 'Increment
                puroDbl3 = 10 'Timeout
                Do While puroDbl1 < puroDbl3
                    If fExist(RunDir & "Watch\Output\" & puroStr2) Then
                        Exit Do
                    End If
                    
                    Delay puroDbl2
                    puroDbl1 = puroDbl1 + puroDbl2
                Loop
                
            'Loop
        End If
    End If
    
    'Read in rate results.
    puroStr1 = Alltrim(XmlReadXPath(puroShipRsXml, "/CreateShipmentResponse/ShipmentPIN/Value/text()"))
    puroStr2 = Alltrim(XmlReadXPath(puroShipRsXml, "/CreateShipmentResponse/PiecePINs/PIN[" & Str(csOrdCount) & "]/Value/text()"))
    
    CS32.SetVar "xTRACK_MOM", puroStr1
    CS32.SetVar "xTRACK_NO", puroStr1
    
    If csExpCount - csOrdCount > 1 Then
        CS32.SetVar "xSHP_CHG", "0"
        CS32.SetVar "xTOT_CHG", "0"
        CS32.SetVar "xFSC_CHG", "0"
        CS32.SetVar "xDDP_CHG", "0"
        CS32.SetVar "xAOD_CHG", "0"
        CS32.SetVar "xCOD_CHG", "0"
        CS32.SetVar "xCVD_CHG", "0"
        CS32.SetVar "xCVP_CHG", "0"
    End If

End Sub

Private Function SendRequest(ByVal puroTransXml As String, ByVal puroTransType As String, ByVal puroTransID As String, ByVal puroAcctID As String) As String
    Dim puroHttp As MSXML2.ServerXMLHTTP60
    Dim sPuroKey As String, sPuroUrl As String, sPuroSOAPAction As String
    
    'PopStatus "Endicia Label Server", "Sending " & puroXmlPrefix
    
    puroTransID = Alltrim(puroTransID)
    puroTransID = StrTran(puroTransID, "\", "_")
    puroTransID = StrTran(puroTransID, "/", "_")
    puroTransID = StrTran(puroTransID, ":", "_")
    puroTransID = StrTran(puroTransID, "*", "_")
    puroTransID = StrTran(puroTransID, "?", "_")
    puroTransID = StrTran(puroTransID, "<", "_")
    puroTransID = StrTran(puroTransID, ">", "_")
    puroTransID = StrTran(puroTransID, "|", "_")
    
    'Save file
    puroStr1 = ""
    Do While fExist(puroDir & "XML\" & puroTransID & puroStr1 & ".xml")
        puroStr1 = Alltrim(Str(Val(puroStr1) - 1))
    Loop
    puroTransID = puroTransID & puroStr1
    
    puroInt1 = FreeFile
    Open puroDir & "XML\" & puroTransID & ".xml" For Output As #puroInt1
    Print #puroInt1, puroTransXml
    Close #puroInt1
    
    puroStr1 = "/Purolator/Accounts/Account[@id='" & puroAcctID & "']/"
    
    puroTestMode = XmlReadXPath(puroCfgXml, puroStr1 & "@test") = "YES"
    If puroTestMode Then
        puroServer = "devwebservices.purolator.com"
        sPuroKey = "ODdiY2MxYTMzYTRjNDE2ZWE0YzdmZGY1YzBmNDk1NmM6RHRlNV5MdT8="
    Else
        puroServer = "webservices.purolator.com"
        sPuroKey = XmlReadXPath(puroCfgXml, puroStr1 & "Authorization/text()")
    End If
    
    If Lower(puroTransType) = "rate" Then
        sPuroUrl = "/EWS/V1/Estimating/EstimatingService.asmx"
        sPuroSOAPAction = "http://purolator.com/pws/service/v1/GetFullEstimate"
    ElseIf Lower(puroTransType) = "ship" Then
        sPuroUrl = "/EWS/V1/Shipping/ShippingService.asmx"
        sPuroSOAPAction = "http://purolator.com/pws/service/v1/CreateShipment"
    ElseIf Lower(puroTransType) = "getlabel" Then
        sPuroUrl = "/EWS/V1/ShippingDocuments/ShippingDocumentsService.asmx"
        sPuroSOAPAction = "http://purolator.com/pws/service/v1/GetDocuments"
    End If
    
    puroTransXml = StrTran(puroTransXml, vbTab, "")
    puroTransXml = StrTran(puroTransXml, vbLf, "")
    'puroTransXml = URLEncode(puroTransXml)
    
    Set puroHttp = New MSXML2.ServerXMLHTTP60
    'puroHttp.SetProxy 2, "https=127.0.0.1:8888"
    puroHttp.SetProxy 2, "https=www-proxy.sandvik.com:8080"
    puroHttp.setOption 2, 13056
    puroHttp.SetTimeouts 30000, 30000, 30000, 30000
    puroHttp.Open "POST", "https://" & puroServer & sPuroUrl, False
    puroHttp.SetRequestHeader "User-Agent", "Mozilla/4.0"
    puroHttp.SetRequestHeader "Content-Type", "text/xml; charset=utf-8"
    puroHttp.SetRequestHeader "Authorization", "Basic " & sPuroKey
    puroHttp.SetRequestHeader "SOAPAction", sPuroSOAPAction
    puroHttp.SetRequestHeader "Host", puroServer
    puroHttp.Send puroTransXml
    puroStr1 = puroHttp.ResponseText
    

    
    puroInt1 = InStr(puroStr1, "<?")
    If puroInt1 > 0 Then
        puroStr2 = SubStr(puroStr1, puroInt1)
        puroInt1 = InStr(puroStr2, ">")
        puroStr2 = Left(puroStr2, puroInt1 + 1)
        puroStr1 = StrTran(puroStr1, puroStr2, "")
    End If
    
    puroInt1 = InStr(XC1, "<")
    If puroInt1 > 0 Then
        puroStr1 = SubStr(puroStr1, puroInt1)
        puroInt1 = InStr(puroStr1, ">")
        puroStr2 = Left(puroStr1, puroInt1 + 1)
        puroInt1 = InStr(puroStr2, " ")
        If puroInt1 > 0 Then
            puroStr1 = StrTran(puroStr1, puroStr2, Left(puroStr2, puroInt1 - 1) & ">")
        End If
    End If
    
    If InStr(puroStr1, "<s:Body>") > 0 Then
        puroStr1 = SubStr(puroStr1, InStr(puroStr1, "<s:Body>") + 8)
        
        puroStr1 = Left(puroStr1, InStr(puroStr1, "</s:Body>") - 1)
    End If
    
    SendRequest = puroStr1
    
    'If logLvl >= 2 Then
    '    logTxt = "ELS: Response received."
    '    'LogWrite
    'End If
    'Debug(puroResponseXml)
    
    'Save response to file.
    puroInt1 = FreeFile
    Open puroDir & "XML\" & puroTransID & "-response.xml" For Output As #puroInt1
    Print #puroInt1, SendRequest
    Close #puroInt1
End Function

Private Function XmlWriteTag(ByVal strTagName As String, ByVal strValue As String) As String
    XmlWriteTag = "<" & strTagName & ">" & XmlSafe(strValue) & "</" & strTagName & ">"
End Function

Private Function XmlReadXPath(ByRef xmlDoc As MSXML2.DOMDocument60, strXPath As String) As String
    XmlReadXPath = ""
    If xmlDoc Is Nothing Then
        Exit Function
    End If
    
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    xmlDoc.setProperty "SelectionLanguage", "XPath"
    Set xmlNode = xmlDoc.selectSingleNode(strXPath)
    
    If Not (xmlNode Is Nothing) Then
        XmlReadXPath = xmlNode.Text
    End If
    Set xmlNode = Nothing
End Function
Private Function XmlReadXPathFromText(strXmlText As String, strXPath As String) As String
    Dim xmlDoc As MSXML2.DOMDocument60
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    Set xmlDoc = New MSXML2.DOMDocument60
    xmlDoc.loadXML strXmlText
    xmlDoc.setProperty "SelectionLanguage", "XPath"
    
    Set xmlNode = xmlDoc.selectSingleNode(strXPath)
    
    XmlReadXPathFromText = ""
    If Not (xmlNode Is Nothing) Then
        XmlReadXPathFromText = xmlNode.Text
    End If
    Set xmlNode = Nothing
End Function

Private Function XmlSafe(strValue As String) As String
    XmlSafe = strValue
    
    XmlSafe = StrTran(XmlSafe, "&", "&amp;")
    XmlSafe = StrTran(XmlSafe, "<", "&lt;")
    XmlSafe = StrTran(XmlSafe, ">", "&gt;")
    XmlSafe = StrTran(XmlSafe, """", "&quot;")
End Function

Private Function URLEncode(StringVal As String, Optional SpaceAsPlus As Boolean = False) As String
    URLEncode = StringVal
    
    Dim StringLen As Long: StringLen = Len(StringVal)
    
    If StringLen > 0 Then
        ReDim result(StringLen) As String
        Dim i As Long, CharCode As Integer
        Dim Char As String, Space As String
        
        If SpaceAsPlus Then Space = "+" Else Space = "%20"
        For i = 1 To StringLen
            Char = Mid$(StringVal, i, 1)
            CharCode = Asc(Char)
            Select Case CharCode
                Case 97 To 122, 65 To 90, 48 To 57, 45, 46, 95, 126
                    result(i) = Char
                Case 32
                    result(i) = Space
                Case 0 To 15
                    result(i) = "%0" & Hex(CharCode)
                Case Else
                    result(i) = "%" & Hex(CharCode)
            End Select
        Next i
        URLEncode = Join(result, "")
    End If
End Function

Public Sub PrintLabel(Optional sTrackNo As String)
    If KiEmpty(sTrackNo) Then
        sTrackNo = Alltrim(CS32.GetVar("xxTRACK_NO"))
    End If
    
    puroStr1 = puroDir & "Labels\" & sTrackNo & ".pdf"
    If fExist(puroStr1) Then
        puroStr2 = XmlReadXPath(puroCfgXml, "/Purolator/Workstations/Workstation[@type='" & Upper(Alltrim(CS32.GetVar("xWORKSTATION"))) & "']/LabelPrinter/text()")
        puroStr3 = "/t " & _
            """" & puroStr1 & """" & " " & _
            """" & puroStr2 & """"
            
        WinExec CS32.ShipDir & "Logic\FRP\FoxitReaderPortable.exe " & (puroStr3)
    Else
        MsgBox "Unabled to print label! """ & puroStr1 & """ is missing.", vbCritical, "Purolator Label Print"
    End If
End Sub
